Updated: 12/07/2011 Due date:
Subject: Cmake with snowballs
Description

Tried configuring Cmake to use snowballs.  When I built the install project inside VS2008, I checked the default directory for the
installation and no snowball files were installed.  I checked the build log and there is no mention of it either.

History
#1 - 06/22/2011 10:00 pm - shuawinn

shuawinn wrote:

Tried configuring Cmake to use snowballs.  When I built the install project inside VS2008, I checked the default directory for the installation and no
snowball files were installed.  I checked the build log and there is no mention of it either.

Commented out in cmake, just needs prebuilt Nel libraries to find them.

#2 - 06/22/2011 10:37 pm - dfighter
- File sb.diff added

Builds more or less with these changes.
The snowballs frontend service fails with this error tho

1>Linking...
1>MSVCRTD.lib(crtexe.obj) : error LNK2019: unresolved external symbol main referenced in function __tmainCRTStartup
1>E:\projects\ryzom_new\ryzom\build\bin\Debug\snowballs_frontend_service.exe : fatal error LNK1120: 1 unresolved externals

#3 - 06/23/2011 05:46 pm - molator

I switched the subsystem from Console to Windows to remove that issue.

#4 - 06/23/2011 06:03 pm - dfighter
- File sb2.diff added

I can confirm that, changing the subsystem really fixes the link error.
Updated my diff to reflect this change.
#5 - 06/23/2011 06:35 pm - rti

Without having looked into the code... is it possible that the service does not implement main() but WinMain()?
If this is the case, changing the program entry point signature might be more cross-platform :)

#6 - 06/23/2011 06:56 pm - kervala

rti wrote:

Without having looked into the code... is it possible that the service does not implement main() but WinMain()?
If this is the case, changing the program entry point signature might be more cross-platform :)

Like dfighter proposed, Adding WIN32 to ADD_EXECUTABLE is the right fix for that :) It doesn't break anything on other platforms (it's simply
ignored).

WinMain is for DLLs and GUI applications (without console) under Windows.

main is for console applications.

Qt is using a trick, they created a qtmain library which implements WinMain and call your main.

You can too force the use of main instead of WinMain for GUI applications but it's not the right way to do it.

#7 - 06/23/2011 07:00 pm - dfighter
- File sb3.diff added

Another update, now "building" the INSTALL project will work too. It had the wrong Qt search path set up and it was referring to a Data directory that
doesn't exist.
Also I think I will work a bit on it, and make it "unified" like the Ryzom projects are so that we will only have to select the client and server once in the
main CMake config dialog. ^^

#8 - 06/23/2011 07:02 pm - rti

I see. So I assume it is the NeL service creation voodoo which creates the WinMain() on windows and would create main() on other platforms. 
I should have looked into the code :)

#9 - 06/23/2011 07:15 pm - dfighter

No rti, that WIN32 is CMake.
The service creation voodoo magic macro is called "NLNET_SERVICE_MAIN".

#10 - 06/23/2011 07:35 pm - rti

Yes, I understand. 
And NLNET_SERVICE_MAIN generates the service's main()/WinMain() function. Correct?
I just thought in the beginning there is a hardcoded WinMain() function in the code. 
But since the NeL macro is used, everything is fine and I should have just shut up in the first place. :)

#11 - 06/23/2011 07:37 pm - dfighter

Yes it does. :)

#if defined(NL_OS_WINDOWS) && defined(_WINDOWS)
#define NLNET_SERVICE_MAIN(__ServiceClassName, __ServiceShortName, __ServiceLongName, __ServicePort,
__ServiceCallbackArray, __ConfigDir, __LogDir) \
 \
int APIENTRY WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) \
{ \
    NLMISC::CApplicationContext    serviceContext; \
    __ServiceClassName *scn = new __ServiceClassName; \
    scn->setArgs (lpCmdLine); \
    createDebug(NULL,!scn->haveLongArg("nolog"));\
    scn->setCallbackArray (__ServiceCallbackArray, sizeof(__ServiceCallbackArray)/sizeof(__ServiceCallbackArray[0])); \
    sint retval = scn->main (__ServiceShortName, __ServiceLongName, __ServicePort, __ConfigDir, __LogDir, __DATE__" "__TIME__); \
    delete scn; \
    return retval; \
}

#else
#define NLNET_SERVICE_MAIN(__ServiceClassName, __ServiceShortName, __ServiceLongName, __ServicePort,
__ServiceCallbackArray, __ConfigDir, __LogDir) \
 \
int main(int argc, const char **argv) \
{ \
    NLMISC::CApplicationContext serviceContext; \
    __ServiceClassName *scn = new __ServiceClassName; \
    scn->setArgs (argc, argv); \
    createDebug(NULL,!scn->haveLongArg("nolog"));\
    scn->setCallbackArray (__ServiceCallbackArray, sizeof(__ServiceCallbackArray)/sizeof(__ServiceCallbackArray[0])); \
    sint retval = scn->main (__ServiceShortName, __ServiceLongName, __ServicePort, __ConfigDir, __LogDir, __DATE__" "__TIME__); \
    delete scn; \
    return retval; \
}

#endif

#12 - 06/23/2011 07:53 pm - dfighter
- File sb4.diff added

Ok here's the latest diff :D
    -  Removed some duplicate calls to package find.
    -  It will now only look for Qt if WITH_QT is selected.
    -  Removed the BUILD_SERVER, BUILD_CLIENT, ENABLE_SOUND options, and now it will use WITH_SNOWBALLS_CLIENT and
WITH_SNOWBALLS_SERVER

#13 - 06/23/2011 08:37 pm - shuawinn

Molator found a fix the source files for running the server end of things.  The program is looking in an incorrect directory for the config files.  They need
to have an update at the end of the file when the NLNET_SERVICE_MAIN is called. Collision works fine but the FES, Chat, and POS files need to be
fixed.  I'm still looking for a fix for the client, as the binary still thinks the default for the config file isn't where it actually is.

#14 - 08/19/2011 02:47 pm - kervala
- Category set to Build
- Status changed from New to Assigned
- Assignee set to kervala

#15 - 08/19/2011 02:54 pm - sfb
- Status changed from Assigned to Resolved
- Target version set to Version 0.9.0

This was completed in r1770 - sorry I was unaware that there was an issue open.

#16 - 08/19/2011 03:08 pm - kervala
- % Done changed from 0 to 100

#17 - 08/19/2011 08:01 pm - molator

I have added in code\nelns\login_system\nel_launcher_qt\CMakeLists.txt :
${QT_QTMAIN_LIBRARY} in TARGET_LINK_LIBRARIES() to avoid the WinMain issue.

#18 - 08/20/2011 06:49 pm - molator
- File nel_launcher_qt.diff added

Here come the little patch.

#19 - 08/22/2011 09:09 am - kervala

Thanks dfighter and molator for your patch :)

#20 - 08/22/2011 03:31 pm - molator
- File snowballs.diff added

Snowballs client no longer looks for the config file next to the binary.
Here a puny patch to temporary fix that issue.
#21 - 08/22/2011 03:34 pm - molator

Beware it's windows only.

#22 - 08/22/2011 03:38 pm - molator
- File snowballs2.diff added

The same patch but with linux compatibility.

#23 - 12/07/2011 02:52 pm - sfb
- Status changed from Resolved to Closed

If anyone else dives into the unholy depths of Snowballs please open a new issue with your specific problem.

Files
sb.diff 3.3 kB 06/22/2011 dfighter
sb2.diff 3.7 kB 06/23/2011 dfighter
sb3.diff 4.8 kB 06/23/2011 dfighter
sb4.diff 7.5 kB 06/23/2011 dfighter
nel_launcher_qt.diff 841 Bytes 08/20/2011 molator
snowballs.diff 835 Bytes 08/22/2011 molator
snowballs2.diff 994 Bytes 08/22/2011 molator
